package servidor.remoto;

import java.io.IOException;
import java.io.PrintStream;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.NoSuchElementException;
import java.util.Scanner;

import servidor.Hash;



public class ControlodarRemoto
{
	private Socket sock = null;
	private PrintStream out = null;
	private Scanner in = null;
	private Scanner kbd = null;
	
	public boolean init(int port, String ip, String password)
	{
		try
		{
			sock = new Socket(ip, port);
			out = new PrintStream(sock.getOutputStream());
			in = new Scanner(sock.getInputStream());
		}
		catch (UnknownHostException e)
		{
			System.out.println("Host no funciona.");
			return false;
		}
		catch (IOException e)
		{
			System.out.println("Conexin fallida.");
			return false;
		}
		
		authenticate(password);
		out.println(" ");
		out.flush();
		if (!sock.isConnected())
		{
			System.out.println("Password incorrecto.");
			return false;
		}
		return true;
	}
	
	public void start()
	{
		new Thread()
		{
			public void run()
			{
				kbd = new Scanner(System.in);
				String input;
				while (sock.isConnected())
				{
					input = kbd.next();
					out.println(input);
					out.flush();
				}
			}
		}.start();
		
		new Thread()
		{
			public void run()
			{
				String input;
				while (sock.isConnected())
				{
					try
					{
						input = in.nextLine();
						System.out.println(input);
					}
					catch (NoSuchElementException e)
					{

						System.out.println("Desconectado.");
						System.exit(0);
					}
				}
			}
		}.start();
	}
	
	private void authenticate(String pass)
	{
		String salt = in.next();
		out.println(Hash.Sha1(salt+pass));
	}
}
